Subject: Re: [weirds] Comments on draft-ietf-weirds-json-response-05

From: Ernie Dainow <[email-masked]>
Date: Tue, 10 Sep 2013 13:50:38 -0400

I've done some testing against a Unicode database table containing
  semaine
  sémaphore
  semblant
  séminaire

And confirmed that:
Search se*  \u73\u65\*
   semaine
   semblant
Search sé*  \u73\uE9\*
   sémaphore
   séminaire

However, this pattern is not the same for all languages. If a diacritical
mark  is not combined with the character into a single Unicode point (in
NFC) as for é above, then the character combined with all diacriticals are
matched. Here is an example from Hebrew.

Search *א  \u05d0\*
אב  u'\u05d0\u05d1'
אַב  u'\u05d0\u05b7\u05d1'
אָב  u'\u05d0\u05b8\u05d1'

But a search that includes the diacritical only matches that one.
Search *אַ  \u05d0\u05b7\*
אַב  u'\u05d0\u05b7\u05d1'

It might be worth noting these differences and dependencies on languages in
the json-response document.

Another confusing issue to be aware of is that for right-to-left languages,
when the user enters the search string "abc" followed by *, it may be
displayed as either cba* or *cba. While there is a Unicode Bidirectional
(bidi) algorithm, the real world fact is that there are plenty of
differences between environments. For example, in FireFox, entering abc* in
the url address line appears as cba* but when the Google search page comes
up, it appears as *cba in the Search box. Generally this is a local display
only and the Unicode is transmitted with the * at the end of the string, as
shown in the examples above. If it is not, then an RDAP search as currently
defined should fail.

-Ernie

On Wed, Aug 28, 2013 at 5:13 AM, Linlin Zhou <[email-masked]> wrote:

> Store the data in databases with the NFC normalization form and search for
> "abc*" or "abç*" also in NFC, I feel this is the most straightforward way
> for this issue.
>
> Regards,
> Linlin
>
> > -----Original Message-----
> > From: [email-masked] [mailto:[email-masked]] On
> Behalf Of
> > John Levine
> > Sent: Tuesday, August 27, 2013 5:34 AM
> > To: [email-masked]
> > Subject: Re: [weirds] Comments on draft-ietf-weirds-json-response-05
> >
> > >I believe most people doing an RDAP search for "se*" would expect to
> > >get the whole list. With NFC normalization, they will only get
> > >     semaine
> > >     semblant
> >
> > Unfortunately, this is a tarpit.  While the French consider e and  to be
> > approximately the same, the Swedes consider a, , and  to be as different
> as a,
> > b, and c.
> >
> > I think the least bad we can do is to say that searches are against NFC
> strings,
> > and if you want to find accented characters, you have to search for them.
> >
> > R's,
> > John
>
> _______________________________________________
> weirds mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/weirds
>

---

From: Ernie Dainow <[email-masked]>
Date: Tue, 10 Sep 2013 14:33:03 -0400

Generally when someone submits a search, they are trying to discover what
names exist. After they get a list of results, they may then do an exact
lookup on particular names to get more details. I don't think we can
anticipate what details they may be interested in, so I don't think we need
to return anything other than a simple list of names, as in

     "names" : [ "1.example.com", "2.example.com", ... ]

This can be used for all search results, domains, nameservers and entities.

In particular, since domain handles cannot be used for any kind of lookup,
there does not seem to be much value in returning them.

An argument can be made for removing handles from all RDAP objects, unless
they can be used for lookups. The only handles in this category are
entities. Domain, nameserver and ip handles seem superfluous. Or am I
missing something useful that a client or end user might do with a handle?

-Ernie

On Tue, Aug 20, 2013 at 2:00 PM, Andy Newton <[email-masked]> wrote:

> On 8/20/13 12:09 PM, "Ernie Dainow" <[email-masked]> wrote:
>
> >9.  Responding To Searches
> >
> >The domains array returned from a search
> >
> >"domains" :
> >      [
> >        {
> >          "handle" : "1-XXXX",
> >          "name" : "1.example.com",
> >          ...
> >        },
> >
> >seems inconsistent with the request in draft-ietf-weirds-rdap-query-06
> >and with domain responses already defined. It should have "ldhName" or
> >"unicodeName" (or both) instead of "name".
>
> This was a cut&paste error. Thanks.
>
> >Domains is a new array, not used elsewhere. But "nameservers" and
> >"entities" arrays returned from search are already defined, as quite
> >large structures. Does this mean the server can return any subset of
> >information from these structures in a search response? This will result
> >in a rather lengthy response for an entities search by name, since the
> >name ("fn") is embedded inside the vcardArray. Some examples here would
> >help. I think simple new arrays specific for "nameservers" and
> >"entities" search results might be preferable.
>
> Would 'entitySearchResults', 'nameserverSearchResults', and
> 'domainSearchResults' work better?
>
> -andy
>
>